/*
Tutorial n1 pour les plugin video de K!TV-XP 1.1

Apprenez la base des plugin de K!TV-XP 1.1

Ce plugin ne semble pas fonctionner en mode d'affichage : DIB,
mais fonctionne en OVERLAY
Par contre, le choix de captureX est quelconque

Par askywhale (2001) (askywhale@free.fr)
Utilisez ces lignes comme bon vous semble
*/

#include <stdio.h> // utilisation de sprintf
#include "..\..\plugin\pluginvideo.h" //fichier donn par k!

int ty=288 /* constante mais a changera peut-tre*/, tx, CurrentFrame;

/*
 Variables utilises partout
 ty = 288. A noter : 'vrai ty' = ty*2 si fullfield == TRUE
	dans ce cas il y a les trames paires (constitues des lignes 
	captures no 0, 2, ... 286,	et les trames impaires
	Qu'il faux traiter l'une aprs l'autre pour une mme image
	(dans un ordre dpendant de la carte tv parait-il)
 tx = vidPlug.CurrentX
*/

// Pr - dclarations
BOOL Start();
BOOL Stop();
void InitStuff();
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);
void CheckStuff(void);	
void ShowDialog();
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
void GetStatus(char * Text, BOOL Nb);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();
BOOL DetecteSignal(BYTE *VBI);

// Cration d'une instance de l'objet de type KTV_vidPlug
QuenotteTV_VideoPlugin vidPlug;

// Dclaration de cette instance  K!TV.exe
extern "C" __declspec( dllexport )QuenotteTV_VideoPlugin * GetVPlugin()
{
	vidPlug.version = VIDEO_PLUGIN_VERSION;
	vidPlug.description = "Plugin Tutorial 1 (You)";
	
	vidPlug.VIA_FIX = false;
	vidPlug.AutoProcessVideo = true;
	vidPlug.VIA_FIX_X=638;	

	vidPlug.accel = NULL;
	vidPlug.NbAccel = 0;

	vidPlug.Start=Start;
	vidPlug.Stop=Stop;	

	vidPlug.InitStuff=InitStuff;
	vidPlug.DoStuff=DoStuff;
	vidPlug.CheckStuff=CheckStuff;

	vidPlug.ShowDialog=ShowDialog;
	vidPlug.UpdateMenu=UpdateMenu;	
	vidPlug.ProcessMessage=ProcessMessage;

	vidPlug.GetStatus=GetStatus;
	vidPlug.SetLow=SetLow;
	vidPlug.AutoMovieBoostFound=AutoMovieBoostFound;
	vidPlug.DetecteSignal=DetecteSignal;
	return &vidPlug;
}

/*
Start : appele quand on appuie sur F3
renvoie false si a marche pas
*/
BOOL Start()
{		
	return TRUE;
}

/*
Stop : appele  la fin
renvoie false si a marche pas
*/
BOOL Stop()
{
	return TRUE;
}

/*
InitStuff : Lanc juste aprs Start
*/
void InitStuff()
{	
}		

/*
Appel le plus souvent possible
	 D'aprs Saint Albator : 
 "Effectue les calculs internes

 UpdateBuffer :
 True : la trame isodd doit etre copie dans le buffer vido
 False: ne rien faire

 ViewBuffer
 true : le buffer vido doit etre visible (overlayflip)
 false: ne pas flip(er)"

 Ici : Fonction exemple : effet miroir
*/
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer)
{		
	*UpdateBuffer = TRUE; //mon plugin est un plugin d'affichage
	*ViewBuffer = bIsOdd; 
	/*je n'affiche pas ce que je viens de faire
	si je suis en fullfield (cad il y a des trames paires et des impaires)
	et que je suis dans une trame paire) : alors bIsOdd == FALSE
	*/
	int ligne;	
	CurrentFrame = vidPlug.CurrentFrame;
	if(vidPlug.FullField) 
	{
		// si je suis dans une trame impaire (odd)
		if(bIsOdd)
		{
			/*
				Je commence  la premire ligne non-noire (dans le cas
				de movieboost>0)
				Et je commence l'effet miroir  la moitie de l'cran
			*/	
			for ( ligne=vidPlug.MovieBoost; ligne < ty/2; ligne++ )	
			{		
				vidPlug.OutOddLines[CurrentFrame][ligne] = 
					vidPlug.OddLines[CurrentFrame][ligne];
			}	
			for ( ligne=ty/2; ligne < ty-vidPlug.MovieBoost; ligne++ )	
			{		
				vidPlug.OutOddLines[CurrentFrame][ligne] = 
					vidPlug.OddLines[CurrentFrame][ty-1-ligne];
			}	
		}
		else
		{		
			for ( ligne=vidPlug.MovieBoost; ligne < ty/2; ligne++ )	
			{	
				vidPlug.OutEvenLines[CurrentFrame][ligne] = 
					vidPlug.EvenLines[CurrentFrame][ligne];
			}	
			for ( ligne=ty/2; ligne < ty-vidPlug.MovieBoost; ligne++ )	
			{	
				vidPlug.OutEvenLines[CurrentFrame][ligne] = 
					vidPlug.EvenLines[CurrentFrame][ty-1-ligne];
			}	
		}
	}
	else
	{
		//alors bIsOdd est toujours vrai
		for ( ligne=vidPlug.MovieBoost; ligne < ty/2; ligne++ )	
		{		
			vidPlug.OutOddLines[CurrentFrame][ligne] = 
			vidPlug.OddLines[CurrentFrame][ligne];				
		}		
		for ( ligne=ty/2; ligne < ty-vidPlug.MovieBoost; ligne++ )	
		{		
			vidPlug.OutOddLines[CurrentFrame][ligne] = 
			vidPlug.OddLines[CurrentFrame][ligne];				
		}		
	}
}

/*
Vrif quelconque, appel presque toutes les secondes je crois
*/
void CheckStuff(void)
{
	
}	

/*
Dialog box : pour changer les options
*/
void ShowDialog()
{
	MessageBox(vidPlug.hwndParent,"Hello !","Dialog box de Show Dialog du tut 1",MB_OK);
}

/*
Modifie le menu principal au lancement
*/
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu)
{
	
}

/*
Pour y envoyer les messages le concernant (raccoucis clavier)
*/
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{
	return FALSE;
}


/*
Affiche des trucs sur la barre des status 
*/
void GetStatus(char * Text, BOOL Nb)
{
	char s[128];
	sprintf(s,"cX:%d, cF:%d, mB:%d, FF:%d", vidPlug.CurrentX, vidPlug.CurrentFrame, vidPlug.MovieBoost, vidPlug.FullField);
	strcpy(Text, s);	
}

/*
Truc standard pas bien utile
*/
void SetLow(unsigned char bBrightness)
{
	
}

/*
Accelere le truc en supprimant le haut et le bas
Ce plugin devrai donc dtecter les ligne noires
et s'il y en a, retourner true et changer la 
valeur de vidPlug.MovieBoost
*/
BOOL AutoMovieBoostFound()
{
	return false;
}


// Reconnaissance automatique du signal
//
// Si cette fonction a reconnu une information spcifique dans les donnes VBI ou Vido,
// il peut forcer K!TV  executer le plugin (en retournant TRUE).
//
// Notes:
// - Le mode AutoProcessVideo doit etre activ pour que cette fonctionnalit soit utilise.
//
// - Cette fonction est appele 25 fois par secondes (a chaque image capture).
//   
// - BYTE *pVBI est un pointeur vers les donnes VBI brutes
//   Si pVBI == NULL, alors il n'y a pas de donnes VBI.
//
// - Rien n'empeche d'utiliser le signal vido.
//
BOOL DetecteSignal(BYTE *VBI) 
{
	return true;
}
