/*
Tutorial n2 pour les plugin video de K!TV xp 1.1

Sujet  modification

Apprenez comment faires des modif RGB sur K!TV
Apprenez  faire un menu avec des raccourcis

Par askywhale (2001) (askywhale@free.fr)
Utilisez ces lignes comme bon vous semble
*/
#include <stdio.h> // utilisation de sprintf
#include "..\..\plugin\pluginvideo.h" 

#include "resource.h"		//pour le menu

int CurrentFrame;	
bool onred;  //choisi si a joue sur le rouge (sinon, le bleu)
float * r, * g, *b; //composantes rouges, vert, bleu, voir plus loin
ACCEL accTable = {VK_CONTROL,'r',ID_ONRED};

int ty=288, tx;
// Pr - dclarations
BOOL Start();
BOOL Stop();
void InitStuff();
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);
void CheckStuff(void);	
void ShowDialog();
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
void GetStatus(char * Text, BOOL Nb);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();
BOOL DetecteSignal(BYTE *VBI);

// Cration d'une instance de l'objet de type KTV_vidPlug
QuenotteTV_VideoPlugin vidPlug;

// Dclaration de cette instance  K!TV.exe
extern "C" __declspec( dllexport )QuenotteTV_VideoPlugin * GetVPlugin()
{
	vidPlug.version = VIDEO_PLUGIN_VERSION;
	vidPlug.description = "Plugin Tutorial 2 (You)";
	
	vidPlug.VIA_FIX = false;
	vidPlug.AutoProcessVideo = true;
	vidPlug.VIA_FIX_X=638;	

	vidPlug.accel = NULL;
	vidPlug.NbAccel = 0;

	vidPlug.Start=Start;
	vidPlug.Stop=Stop;	

	vidPlug.InitStuff=InitStuff;
	vidPlug.DoStuff=DoStuff;
	vidPlug.CheckStuff=CheckStuff;

	vidPlug.ShowDialog=ShowDialog;
	vidPlug.UpdateMenu=UpdateMenu;	
	vidPlug.ProcessMessage=ProcessMessage;

	vidPlug.GetStatus=GetStatus;
	vidPlug.SetLow=SetLow;
	vidPlug.AutoMovieBoostFound=AutoMovieBoostFound;
	vidPlug.DetecteSignal=DetecteSignal;
	return &vidPlug;
}

/*
createBuffers : alloue de la mmoire pour les composantes
*/
void createBuffers()
{
	tx = vidPlug.CurrentX;
	if(!tx)
		return;
	if(!r)
		if(vidPlug.FullField)
			r = new float[tx*ty];
		else
			r = new float[tx*ty/2]; 
	if(!g)
		if(vidPlug.FullField)
			g = new float[tx*ty];
		else
			g = new float[tx*ty/2]; 
	if(!b)
		if(vidPlug.FullField)
			b = new float[tx*ty];
		else
			b = new float[tx*ty/2]; 	
}

BOOL Start()
{	
	return TRUE;
}

BOOL Stop()
{
	if(r)
	{	
		delete [] r;
		r=NULL;
	}
	if(g)
	{	
		delete [] g;
		g=NULL;
	}
	if(b)
	{	
		delete [] b;
		b=NULL;
	}
	return TRUE;
}


void InitStuff()
{	
	r = NULL;
	g = NULL;
	b = NULL;
	createBuffers();
	/*
	createBuffer le plus tard possible, car j'ai besoin de connaitre
	CurrentX
	*/
	onred = true;
}		

/* 
Quatre fonctions trs trs lentes pour convertir RGB->YUV et inversement

Attention, dans ces fonctions : tx = (tx global)/2

Mais pourquoi ?
	Parce que, contrairement au codage, les points YUV 
	ne sont pas des short mais de DWORD (4 octets)
	Il y a donc 2 fois moins de points que CurrentX ne l'indique
	au total il y a : 
		tx*ty points si utilisation des lignes paires et impaires (Fullfield)
		tx*ty/2 points sinon
*/
void inline YUV2RGB(DWORD e, float * r, float * g, float * b)
{
	float u = float((e>>8) & 0xff);
	float v = float((e>>24) & 0xff);	
	float tmp = 1.164f*((e&0xff) - 16);
	*r = tmp + 1.596f*(v - 128);
	*g = tmp - 0.813f*(v - 128) - 0.391f*(u - 128);
	*b = tmp + 2.018f*(u - 128);	
}

void inline RGB2YUV(DWORD * e, float r, float g, float b)
{	
	int y = int((0.257 * r) + (0.504 * g) + (0.098 * b) + 16);	
	int u = int(-(0.148 * r) - (0.291 * g) + (0.439 * b) + 128);	
	int v = int((0.439 * r) - (0.368 * g) - (0.071 * b) + 128);	
	*e = (v<<24) + (y<<16) + (u<<8) +y;
}

void dwordToRgb(int tx, int ty, short ** es, short ** os, float * r, float * g, float * b)
{
	DWORD ** e = (DWORD **) es;	
	DWORD ** o = (DWORD **) os;	
	int x,y,yy=0;
	float U,V,Y;	
	if((o==NULL)||(o[0]==NULL))
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)
			{
				U = float((e[y][x]>>8) & 0xff);
				V = float((e[y][x]>>24) & 0xff);	
				Y = 1.164f*float((e[y][x]&0xff) - 16); //Y c'est pas a
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}
		}
	else
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)
			{
				U = float((e[y][x]>>8) & 0xff);
				V = float((e[y][x]>>24) & 0xff);	
				Y = 1.164f*float((e[y][x]&0xff) - 16); 
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}			
			for(x=0;x<tx;x++)
			{
				U = float((o[y][x]>>8) & 0xff);
				V = float((o[y][x]>>24) & 0xff);	
				Y = 1.164f*float((o[y][x]&0xff) - 16); 
				r[yy] = Y + 1.596f*(V - 128);
				g[yy] = Y - 0.813f*(V - 128) - 0.391f*(U - 128);
				b[yy] = Y + 2.018f*(U - 128);	
				yy++;
			}	
		}	
}

void rgbToDword(int tx, int ty, short ** es, short ** os, float * r, float * g, float * b)
{
	DWORD ** e = (DWORD **) es;	
	DWORD ** o = (DWORD **) os;
	if((!e)||(!r))return;
	int x,y,yy=0,Y,U,V;
	if((o==NULL)||(o[0]==NULL))
		for(y=0;y<ty;y++)
		{			
			for(x=0;x<tx;x++)				
			{
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				e[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;				
				yy++;
			}
		}
	else
	{
		for(y=0;y<ty;y++)
		{
			for(x=0;x<tx;x++)
			{
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				e[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;				
				yy++;
			}			
			for(x=0;x<tx;x++)
			{				
				Y = int((0.257 * r[yy]) + (0.504 * g[yy]) + (0.098 * b[yy]) + 16);	
				U = int(-(0.148 * r[yy]) - (0.291 * g[yy]) + (0.439 * b[yy]) + 128);	
				V = int((0.439 * r[yy]) - (0.368 * g[yy]) - (0.071 * b[yy]) + 128);	
				o[y][x] = (V<<24) + (Y<<16) + (U<<8) +Y;								
				yy++;
			}
		}
	}
}

/*
Fonction exemple : effet bizarre sur la composante rouge (ou bleu suivant onred)
*/
void doModifs()
{
	if(onred)
		if(vidPlug.FullField)
			for(int i=tx*ty-1;i>-1;i--)
				r[i] = float(int(r[i]*2)&255);
		else
			for(int i=tx*ty/2-1;i>-1;i--)
				r[i] = float(int(r[i]*2)&255);
	else
		if(vidPlug.FullField)
			for(int i=tx*ty-1;i>-1;i--)
				b[i] = float(int(r[i]*2)&255);
		else
			for(int i=tx*ty/2-1;i>-1;i--)
				b[i] = float(int(r[i]*2)&255);
}

/*
Je convertit, je modifie, je convertit, je copie
Ici, fair eun truc gnraliste (si fullfield) est difficile, 
car normalement il faudrait SOIT traiter une frame paire, 
soit une impaire, donc pas de sauvegarde du buffer en utilisant
les fonction ci-dessus.
Je n'ai pas refais les fonction ci-dessus, donc j'ai choisi de
tout traiter lors des frames impaire.
Ca fonctionnerais probablement sur un super proc., mais sinon,
des fois j'ai pas de frame paire pendant un moment (tant sautes
pour cause de lenteur), et donc dfaut graphique.
*/
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer)
{
	*ViewBuffer = bIsOdd;
	*UpdateBuffer = TRUE;
	if(!bIsOdd)
		return;
	CurrentFrame = vidPlug.CurrentFrame;		
	tx = vidPlug.CurrentX;	

	//ralisation des trois buffers
	if(vidPlug.FullField)
		dwordToRgb(tx/2,ty,
			&(vidPlug.EvenLines[CurrentFrame][0]),
			&(vidPlug.OddLines[CurrentFrame][0]),r,g,b);
	else
		dwordToRgb(tx/2,ty,
			&(vidPlug.OddLines[CurrentFrame][0]),NULL,r,g,b);
	//modification
	doModifs();
	//utilisation
	if (vidPlug.FullField)
		rgbToDword(tx/2,ty,
			&(vidPlug.EvenLines[CurrentFrame][0]),
			&(vidPlug.OddLines[CurrentFrame][0]),r,g,b);
	else
		rgbToDword(tx/2,ty,
			&(vidPlug.OddLines[CurrentFrame][0]),NULL,r,g,b);

	// Et maintenant, la copie vers le buffer de sortie
	int ligne;		
	if(vidPlug.FullField) 
	{
		for ( ligne=vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )	
		{		
			vidPlug.OutOddLines[CurrentFrame][ligne] = 
				vidPlug.OddLines[CurrentFrame][ligne];
		}	
		for ( ligne=vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )	
		{	
			vidPlug.OutEvenLines[CurrentFrame][ligne] = 
				vidPlug.EvenLines[CurrentFrame][ligne];
		}		
	}
	else
	{	
		for ( ligne=vidPlug.MovieBoost; ligne < ty-vidPlug.MovieBoost; ligne++ )	
		{		
			vidPlug.OutOddLines[CurrentFrame][ligne] = 
			vidPlug.OddLines[CurrentFrame][ligne];				
		}		
	}
}

void CheckStuff(void)
{

}	

void GetStatus(char *Text, BOOL Nb)
{
	char s[128];
	sprintf(s,"cX:%d, cF:%d, mB:%d, %d", vidPlug.CurrentX, vidPlug.CurrentFrame,
		vidPlug.MovieBoost, onred?1:0);
	strcpy(Text, s);
}

// Quand le filtre n'a pas encore t mis en marche, hMenu = 0
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{	
	HMENU hMenu = GetMenu(vidPlug.hwndParent);	
	bool messageProcessed = false;
	switch (message)
	{
		case WM_COMMAND:
			switch( LOWORD( wParam ))
			{
				case ID_ONRED:
					onred=!onred;
					if(onred)	
					{
						sprintf(OSDDisplay, "Filtre Tutorial : rouge");
						if(hMenu)
							CheckMenuItem( hMenu, ID_ONRED, MF_CHECKED);						
					}
					else
					{
						sprintf(OSDDisplay, "Filtre Tutorial : bleu");
						if(hMenu)
							CheckMenuItem( hMenu, ID_ONRED, MF_UNCHECKED);								
					}
					messageProcessed = true;
				break;
			}
			break;
	}
	return messageProcessed;
}

// execut : une fois au dbut pour ContextMenu = false (barre du haut)
//           a chaque fois pour ContextMenu = true (bouton droit)
void UpdateMenu(HMENU hMenu, HINSTANCE hInst, BOOL ContextMenu)
{
	HMENU menu = LoadMenu(vidPlug.hDllInstance,MAKEINTRESOURCE(IDR_MENU1));
	if(ContextMenu)
		InsertMenu(hMenu, (unsigned int)GetSubMenu(hMenu,4), MF_POPUP,(unsigned int)GetSubMenu(LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1)),0),"&Tutorial");
	else
	{
		ModifyMenu(GetSubMenu(hMenu, 3), 2, MF_BYPOSITION | MF_POPUP, (unsigned int)GetSubMenu(LoadMenu(hInst,MAKEINTRESOURCE(IDR_MENU1)),0), "&Tutorial");
	}
}


void SetLow(unsigned char bBrightness)
{
	
}

BOOL AutoMovieBoostFound()
{
	return false;
}

BOOL DetecteSignal(BYTE *VBI)
{
	return TRUE;
}


BOOL APIENTRY MyProc
(
    HWND hDlg,
    UINT message,
    UINT wParam,
    LONG lParam)
{
   
	switch (message)
	{
        case WM_INITDIALOG:
			break;

        case WM_COMMAND:
			if ((LOWORD(wParam) == IDOK ) || (LOWORD(wParam) == IDCANCEL )) 
			{
				EndDialog(hDlg,TRUE);
			}
			break;
    }
	return(FALSE);
}

void ShowDialog()
{
	DialogBox (vidPlug.hDllInstance, "REGLAGES", vidPlug.hwndParent, MyProc);
}
